`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    01:24:40 03/16/2008 
// Design Name: 
// Module Name:    DCM_CNT 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module DCM_CNT(
						clkM2,
						clkD4,
						rst,
						//M2cnt_out,
						//D4cnt_0ut,
						Led

											);


//-----------  IO -------------------------------


input				clkM2;
input				clkD4;
input				rst;
//output [3:0]	M2cnt_out;
//output [3:0]	D4cnt_0ut;	

output	[7:0]	Led;

//z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{
// |}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|
//wwwwwwww{       zwwwwww{   zwwww{ zwwwwwwwwwww
//			 |wwwwwww}      |www}    |w}

//-----------  REG/WIRE  -------------------------------

reg	 [27:0]	M2cnt;
reg	 [21:0]	D4cnt;
reg	 [3:0]	dcnt;

wire	 [7:0]	Led;

reg				f1;
reg				f3;

//reg	[3:0]		Led_h1;	
//reg	[3:0]		Led_h3;	

wire n_rst = ~rst;

//-----------------<<>>><<<>>>><<<>>------------------------------
//====================== OOOOOOOOOOO =========================	

always @ ( posedge clkM2   ) //50MHZ >> 100MHZ
begin
if ( !n_rst )
	begin M2cnt <= 28'h0; f1 <= 1'b0; end
else
	begin
	//	if ( M2cnt >= 28'h2FAF080 )		 //100 MHZ
		if ( M2cnt >= 28'h0000010 )
			begin f1 <= ~f1;  M2cnt <= 28'h0; end
		else
			begin	M2cnt <= M2cnt + 1 ; f1 <= f1; end
	end
end
//-----------------<<>>><<<>>>><<<>>------------------------------
//====================== OOOOOOOOOOO =========================	

always @ ( posedge clkD4   )     //50MHZ >> 12.5MHZ
begin
if ( !n_rst )
	begin D4cnt <= 22'h0; f3 <= 1'b0; end
else
	begin
		//if ( D4cnt >= 22'h1FCA04 )		 //12.5MHZ
		if ( D4cnt >= 22'h0000004 )
			begin f3 <= ~f3;  D4cnt <= 22'h0; end
		else
			begin	D4cnt <= D4cnt + 1 ; f3 <= f3; end
	end
end
//-----------------<<>>><<<>>>><<<>>------------------------------
//----------------- DIV COUNTER OUT ------------------------------

always @ ( posedge f1 )
begin
	if ( !n_rst )  dcnt <= 4'h0;
else
	dcnt <= dcnt + 1;
end

//====================== OOOOOOOOOOO =========================	

assign Led[0] = dcnt[0];
assign Led[1] = dcnt[1];
assign Led[2] = dcnt[2];
assign Led[3] = dcnt[3];

assign Led[7] = dcnt[0] & f3;
assign Led[6] = dcnt[1] & f3;
assign Led[5] = dcnt[2] & f3;
assign Led[4] = dcnt[3] & f3;


//====================== OOOOOOOOOOO =========================	

endmodule
