`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    01:35:09 03/14/2008 
// Design Name: 
// Module Name:    Demo_Top 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module Demo_Top(
							clk,
							rst,
							sel_ch,
							st,
							// ---------------- +++++++
							Led
							// ---------------- +++++++

							//--------------  ++++

													);
													
//------------------  IO -------------------------------

input				clk;
input				rst;
input	[1:0]		sel_ch;
input				st;
//output			sec_out;	
output [7:0]	Led;

wire	[7:0]	led_ch1;
wire	[7:0]	led_ch2;



//z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{z{
// |}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|}|
//wwwwwwww{       zwwwwww{   zwwwwwwwwwwwwwwwwww
//			 |wwwwwww}      |www}


assign Led = ( sel_ch ==2'b00 )? led_ch1 :
				 ( sel_ch ==2'b11 )? led_ch2 : 	
				 ( sel_ch ==2'b10 )? 8'hAA :8'h55;
				 
//========================OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO

   IBUFG #(
      .IBUF_DELAY_VALUE("0"), // Specify the amount of added input delay for 
                              //   the buffer, "0"-"16" (Spartan-3E/3A only)
      .IOSTANDARD("DEFAULT")  // Specify the input I/O standard
   ) IBUFG_inst1 (
      .O(clk_buf), // Clock buffer output
      .I(clk)  // Clock buffer input (connect directly to top-level port)
  );


//=======OOOO======== CALL Module ============OOO=====

LED_F FFXI_1 (
    .clk(clk_buf), 
    .rst(rst), 
    .st(st), 
    .Led(led_ch1)
   // .sec_out(sec_out)
    );
	 
//-----------------<<>>><<<>>>><<<>>-----------------

Dll_M2D4 FFXI_2 (
    .CLKIN_IN( clk_buf ), 
    .RST_IN( rst ), 
    .CLKDV_OUT( clkD4 ), 
    //.CLKIN_IBUFG_OUT(CLKIN_IBUFG_OUT), 
    .CLK0_OUT( clkM2 ), 
    .LOCKED_OUT( dll_lock )
    );



//-----------------<<>>><<<>>>><<<>>-----------------


DCM_CNT FFXI_3 (
    .clkM2(clkM2), 
    .clkD4(clkD4), 
    .rst(rst), 
    .Led(led_ch2)
    );

//=======OOOO================++++++++++========OOO=====

 
endmodule
